<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/ts/ajaxell/html/elements/ag-toaster/throws-toast.html">

<!--

`ts-ajax` automatically makes ajax requests the XDAQ way.

It is very similar to [`auto-update`](../auto-update/index.html), except for the
fact that this doesn't have an interval, it only makes a request when you ask it to.
Also not that the C++ callback event is 'OnClick' and not 'OnTime' as with
[`auto-update`](../auto-update/index.html).

Example html in your panel:

    <ts-ajax data="{{my_variable}}" callback="cpp_callback" handle-as="text"></ts-ajax>
    <span>{{my_variable}}</span>

Example C++ code:

    void PanelExample::layout(cgicc::Cgicc& cgi)
    {
      setEvent("cpp_callback", ajax::Eventable::OnClick, this, &PanelExample::getsomedata);
      add(new ajax::PolymerElement("my-panel"));
    }
    void PanelExample::getsomedata(cgicc::Cgicc& cgi,std::ostream& out)
    {
      static int times(0);
      times++;
    	std::ostringstream msg;
    	msg << "The PanelExample::updatesomedata method has been executed " << times << " times";
    	out << msg.str();
    }

Example html with parameters:

    <paper-input value="{{favDino}}" label="your favorite dinosaur"></paper-input>
    <ts-ajax data="{{test2}}"
             callback="parametersexample"
             handle-as="text"
             parameters='["favoritedino"]'
             favoritedino="{{favDino}}"
             ></ts-ajax>
             notice the single & double quotes in the parameters variable
             do yourself a favor and do not use capital letters in parameter names
    <span>{{test2}}</span>

Example C++ with parameters:

    void PanelExample::withparametersexample(cgicc::Cgicc& cgi,std::ostream& out)
    {
    	std::ostringstream msg;

    	std::map<std::string,std::string> values(ajax::toolbox::getSubmittedValues(cgi));

    	msg << "Your favorite dinosaur is the ";

    	for(std::map<std::string,std::string>::iterator i(values.begin()); i != values.end(); ++i) {
    			if ( i->first.compare("favoritedino") == 0 ) {
    				msg << i->second;
    			}
    	}

    	out << msg.str();
    }
    void PanelExample::layout(cgicc::Cgicc& cgi)
    {
      setEvent("parametersexample", ajax::Eventable::OnClick, this, &PanelExample::withparametersexample);
      add(new ajax::PolymerElement("my-panel"));
    }

-->

<dom-module id="ts-ajax">
  <template>
    <iron-ajax id="ajax" method="post" on-response="_onResponse" on-error="_onError"></iron-ajax>

  </template>
</dom-module>
<script src="javascript/ts-ajax-min.js?__inline=true"></script>
